<!DOCTYPE html>
<html lang="en"><head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
    <meta charset="utf-8">
    <title>Centralized Clinical Tests</title>
    <meta name="description" content="">
    <meta name="author" content="Nelson Estevão, Pedro Ribeiro, Rui Mendes, Hugo Carvalho, ">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="Centralized%20Clinical%20Tests_files/reset.css">
    <link rel="stylesheet" href="Centralized%20Clinical%20Tests_files/reveal.css">

    <!-- Theme used for syntax highlighting of code -->
    <link rel="stylesheet" href="Centralized%20Clinical%20Tests_files/prism-tomorrow.css">

    <!-- Tidy Styles -->
    <link rel="stylesheet" href="Centralized%20Clinical%20Tests_files/styles.css">

    <!-- Printing and PDF exports -->
    <script>
      var link = document.createElement( 'link' );
      link.rel = 'stylesheet';
      link.type = 'text/css';
      link.href = window.location.search.match( /print-pdf/gi ) ? 'revealjs/css/print/pdf.css' : 'revealjs/css/print/paper.css';
      document.getElementsByTagName( 'head' )[0].appendChild( link );
    </script><link rel="stylesheet" type="text/css" href="Centralized%20Clinical%20Tests_files/pdf.css">

    <!--[if lt IE 9]>
      <script src="lib/js/html5shiv.js"></script>
    <![endif]--><script type="text/javascript" src="Centralized%20Clinical%20Tests_files/marked.js"></script><script type="text/javascript" src="Centralized%20Clinical%20Tests_files/markdown.js"></script><script type="text/javascript" src="Centralized%20Clinical%20Tests_files/highlight.js"></script><script type="text/javascript" src="Centralized%20Clinical%20Tests_files/notes.js"></script><script type="text/javascript" src="Centralized%20Clinical%20Tests_files/prism.js"></script>
  <style type="text/css">.hljs-ln{border-collapse:collapse}.hljs-ln td{padding:0}.hljs-ln-n:before{content:attr(data-line-number)}</style><style type="text/css">@page{size:1408px 792px; margin: 0px;}</style><style type="text/css">.reveal section>img, .reveal section>video, .reveal section>iframe{max-width: 1280px; max-height:720px}</style></head>
  <body class="print-pdf" style="width: 1408px; height: 792px;"><script id="__bs_script__">//<![CDATA[
    document.write("<script async src='/browser-sync/browser-sync-client.js?v=2.26.7'><\/script>".replace("HOST", location.hostname));
//]]></script><script async="" src="Centralized%20Clinical%20Tests_files/browser-sync-client.js"></script>


    <div class="reveal slide has-vertical-slides has-horizontal-slides ready" role="application" data-transition-speed="default" data-background-transition="fade" style="cursor: none;">
      <div class="slides">

        <div class="pdf-page" style="height: 791px;"><div class="slide-background section-title present" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section class="section-title present" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="0">
          <p>Bases de Dados</p>
          <h1>Centralized Clinical Tests</h1>
            <h2> Nelson Estevão </h2>
            <br>
            <h2> Pedro Ribeiro </h2>
            <br>
            <h2> Rui Mendes </h2>
            <br>
            <h2> Hugo Carvalho </h2>
            <br>
        </section></div>

        		<section aria-hidden="true" class="stack present" style="display: block;" data-index-h="1" hidden="">
        					<div class="pdf-page" style="height: 1582px;"><div class="slide-background Introdução e Contextualização present" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section class="Introdução e Contextualização present" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="1" data-index-v="0">
        					
        					  <span class="section-number">1</span>
        					
        					  <h1>Introdução e Contextualização</h1>
        					  <p>
        					    A Centralized Clinical Tests foi a base de dados desenvolvida por nós para
        					    solucionar o problema proposto no enunciado do trabalho prático da cadeira.
        					    Esta solução implementa as relações entre médicos, atletas,
        					    hospitais/clínicas e organizadores de provas.
        					  </p>
        					
        					  <img src="Centralized%20Clinical%20Tests_files/athlete.png" alt="" style="float:right;width=100px;height=100px;">
        					  <aside class="notes">
        					  </aside>
        					
        					</section></div>
        					<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="1" data-index-v="1" hidden=""><h1 id="requisitos-de-descrição">Requisitos de Descrição</h1>
<ol>
<li>Quando um atleta se regista no CCT deve fornecer o seu email, nome, número
de telemóvel, data de nascimento, altura, peso, modalidade e género.</li>
<li>Quando um organizador se regista no CCT tem de fornecer o seu nome, email,
número de telemóvel e o nome da prova que organiza.</li>
<li>Quando um médico se regista no CCT tem de fornecer o seu email, nome,
especialidade médica e hospital a que está contratualmente ligado.</li>
<li>Um atleta pode inscrever-se em diversas provas.</li>
<li>Cada atleta compete numa só modalidade.</li>
</ol>
</section></div>		<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="1" data-index-v="2" hidden=""><h1 id="requisitos-de-exploração">Requisitos de exploração</h1>
<ol>
<li>O atleta deve conseguir agendar testes clínicos.</li>
<li>Deverá ser possível aceder ao stock de equipamentos médicos num hospital.</li>
<li>Deverá ser possível saber quais os exames necessários para a inscrição numa
prova.</li>
</ol>
</section></div>		<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="1" data-index-v="3" hidden=""><h1 id="requisitos-de-controlo-exemplo">Requisitos de controlo (exemplo)</h1>
<ol>
<li>O organizador de um prova deve conseguir aceder apenas às informações dos
atletas inscritos nessa mesma prova, assim como o seu registo clínico.</li>
</ol>
</section></div>		</section>
        		<section aria-hidden="true" class="stack present" style="display: block;" data-index-h="2" hidden="">
        					<div class="pdf-page" style="height: 791px;"><div class="slide-background Modelação concetual e modelação lógica present" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section class="Modelação concetual e modelação lógica present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="2" data-index-v="0" hidden="">
        					
        					  <span class="section-number">2</span>
        					  <h1>Modelação concetual e modelação lógica</h1>
        					
        					  <aside class="notes">
        					  </aside>
        					
        					</section></div>
        					<div class="pdf-page" style="height: 1582px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="2" data-index-v="1" hidden=""><h1 id="modelo-concetual">Modelo Concetual</h1>
<p><img src="Centralized%20Clinical%20Tests_files/conceptual.png" alt="Modelo concetual">{ width=100px; }</p>
</section></div>		<div class="pdf-page" style="height: 1582px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="2" data-index-v="2" hidden=""><h1 id="modelo-lógico">Modelo lógico</h1>
<p><img src="Centralized%20Clinical%20Tests_files/logical.svg" alt="Modelo lógico"></p>
</section></div>		<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="2" data-index-v="3" hidden=""><h1 id="validação-do-modelo-lógico">Validação do modelo lógico</h1>
<p><img src="Centralized%20Clinical%20Tests_files/algebra.png" alt="Álgebra Relacional"></p>
</section></div>		<div class="pdf-page" style="height: 1582px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="2" data-index-v="4" hidden=""><h1 id="espaço-ocupado-por-cada-entrada-de-cabela">Espaço ocupado por cada entrada de cabela</h1>
<table>
<thead>
<tr>
<th>Tabela</th>
<th align="right">Tamanho de uma entrada (em bytes)</th>
</tr>
</thead>
<tbody><tr>
<td>Atleta</td>
<td align="right">285</td>
</tr>
<tr>
<td>Modalidade</td>
<td align="right">132</td>
</tr>
<tr>
<td>Atleta_In_Prova</td>
<td align="right">8</td>
</tr>
<tr>
<td>Exame_In_Consulta</td>
<td align="right">8</td>
</tr>
<tr>
<td>Consulta</td>
<td align="right">30</td>
</tr>
<tr>
<td>Organizador</td>
<td align="right">177</td>
</tr>
<tr>
<td>Prova</td>
<td align="right">156</td>
</tr>
<tr>
<td>ExamsNeededInProva</td>
<td align="right">16</td>
</tr>
<tr>
<td>Exame</td>
<td align="right">56</td>
</tr>
<tr>
<td>Especialidade</td>
<td align="right">132</td>
</tr>
<tr>
<td>Medico</td>
<td align="right">268</td>
</tr>
<tr>
<td>Equipamento_In_Exame</td>
<td align="right">8</td>
</tr>
<tr>
<td>Equipamento</td>
<td align="right">50</td>
</tr>
<tr>
<td>Pedidos_Exame</td>
<td align="right">12</td>
</tr>
<tr>
<td>Hospital</td>
<td align="right">49</td>
</tr>
<tr>
<td>Equipamento_In_Hospital</td>
<td align="right">12</td>
</tr>
</tbody></table>
</section></div>		<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="2" data-index-v="5" hidden=""><p>Crescimento anual estimado da base de dados</p>
<p>Aumentos anuais expectáveis:</p>
<ol>
<li>1000 atletas</li>
<li>50 provas</li>
<li>2 hospitais</li>
<li>1 especialidade médica</li>
<li>20 médicos</li>
<li>5 organizadores de provas</li>
<li>5 equipamentos para realizar exames</li>
<li>5 tipos de exames</li>
</ol>
<p>Feitas as contas: esperamos um aumento de cerca de 0.45 Megabytes por ano.</p>
</section></div>		<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="2" data-index-v="6" hidden=""><h1 id="implementação-das-interrogações-e-procedimentos-em-mysql">Implementação das interrogações e procedimentos em MySQL</h1>
</section></div>		</section>
        		<section aria-hidden="true" class="stack present" style="display: block;" data-index-h="3" hidden="">
        					<div class="pdf-page" style="height: 1582px;"><div class="slide-background section-title present" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section class="section-title present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="3" data-index-v="0" hidden="">
        					  <span class="section-number">3</span>
        					  <h1>Mecanismos de segurança</h1>
        					
        					  <img src="Centralized%20Clinical%20Tests_files/security.png" alt="" style="float:right;height=100px;">
        					
        					  <aside class="notes">
        					  </aside>
        					</section></div>
        					<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="3" data-index-v="1" hidden=""><h1 id="views-por-exemplo-para-o-organizador">Views (por exemplo para o <em>Organizador</em>)</h1>
<pre class=" language-sql"><code class=" hljs language-sql">DROP VIEW IF EXISTS `clinicalTrials`.`viewProvasOrganizador`;
USE `clinicalTrials`;
CREATE OR REPLACE VIEW `viewProvasOrganizador` AS
SELECT o.id                        AS idOrganizador,
       o.nome                      AS nomeOrganizador,
       p.nome                      AS nomeProva,
       m.nome                      AS nomeModalidade,
       COUNT(DISTINCT ap.idAtleta) AS numAtletas
FROM Organizador AS o
        INNER JOIN
    Prova AS p ON o.id = p.idOrganizador
        INNER JOIN
    Modalidade AS m ON p.idModalidade = m.id
        INNER JOIN
    Atleta_In_Prova AS ap ON ap.idProva = p.id
GROUP BY p.id;</code></pre>
</section></div>		<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="3" data-index-v="2" hidden=""><h1 id="procedures-por-exemplo-para-os-atletas"><em>Procedures</em> (por exemplo para os <em>Atletas</em>)</h1>
<pre class=" language-mysql"><code class=" language-mysql">CREATE ROLE Atleta;
GRANT EXECUTE ON PROCEDURE clinicalTrials.checkFutureExams TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.fazerPedidosForProvaHospital TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getConsultasPorEspecialidade TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getExamsDone TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getExamsNeeded TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getFuturasProvas TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getOrganizador TO ATLETA;

CREATE USER 'atleta'@'%' IDENTIFIED BY '123456789';
GRANT ATLETA TO 'atleta'@'%';</code></pre>
</section></div>		</section>
        		<section aria-hidden="true" class="stack present" style="display: block;" data-index-h="4" hidden="">
        					<div class="pdf-page" style="height: 1582px;"><div class="slide-background section-title present" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section class="section-title present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="4" data-index-v="0" hidden="">
        					  <span class="section-number">4</span>
        					  <h1>MongoDB</h1>
        					
        					  <div class="center">
        					    <img src="Centralized%20Clinical%20Tests_files/mongodb.png" alt="" style="float:right;width=100px;">
        					  </div>
        					
        					  <aside class="notes">
        					  </aside>
        					</section></div>
        					<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="4" data-index-v="1" hidden=""><h1 id="migração-da-base-de-dados-mysql-para-mongodb">Migração da base de dados MySQL para MongoDB</h1>
<ol>
<li>Executar o script <em>db_export.sql</em>.</li>
<li>Correr <em>Migrations</em>.</li>
<li>Usar o comando <code>mongoimport --db &lt;bd_name&gt; --collection &lt;collection_name&gt;
--file &lt;json file_name&gt; -jsonArray</code> para cada um dos ficheiros <em>json</em>
gerados.</li>
</ol>
</section></div>		<div class="pdf-page" style="height: 791px;"><div class="slide-background future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><section data-markdown="" data-markdown-parsed="true" class="present" aria-hidden="true" style="display: block; left: 64px; top: 36px; width: 1280px;" data-index-h="4" data-index-v="2" hidden=""><h1 id="implementação-das-interrogações-em-mongodb">Implementação das interrogações em MongoDB</h1>
</section></div>		</section>
      </div>
    <div class="backgrounds"><div class="slide-background stack future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><div class="slide-background stack future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><div class="slide-background stack future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div><div class="slide-background stack future" style="display: block;" data-loaded="true"><div class="slide-background-content"></div></div></div><div class="progress" style="display: block;"><span style="width: 0px;"></span></div><aside class="controls" style="display: block;" data-controls-layout="bottom-right" data-controls-back-arrows="faded"><button class="navigate-left" aria-label="previous slide" disabled="disabled"><div class="controls-arrow"></div></button><button class="navigate-right enabled" aria-label="next slide"><div class="controls-arrow"></div></button><button class="navigate-up" aria-label="above slide" disabled="disabled"><div class="controls-arrow"></div></button><button class="navigate-down enabled highlight" aria-label="below slide"><div class="controls-arrow"></div></button></aside><div class="slide-number" style="display: none;"></div><div class="speaker-notes" data-prevent-swipe="" tabindex="0"></div><div class="pause-overlay"><button class="resume-button">Resume presentation</button></div><div style="position: absolute; height: 1px; width: 1px; overflow: hidden; clip: rect(1px, 1px, 1px, 1px);" id="aria-status-div" aria-live="polite" aria-atomic="true">
          Bases de Dados
          Centralized Clinical Tests
             Nelson Estevão 
            
             Pedro Ribeiro 
            
             Rui Mendes 
            
             Hugo Carvalho 
            
        </div></div>

    <script src="Centralized%20Clinical%20Tests_files/reveal.js"></script>
    <script>
      Reveal.initialize({
        controls: true,
        progress: true,
        center: false,
        hash: true,
        history: true,
        width: 1280,
        height: 720,
        margin: 0.1,
        transition: 'slide', // none/fade/slide/convex/concave/zoom

        // More info https://github.com/hakimel/reveal.js#dependencies
        dependencies: [
          { src: 'revealjs/plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
          { src: 'revealjs/plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
          { src: 'revealjs/plugin/highlight/highlight.js', async: true },
          // { src: 'revealjs/plugin/search/search.js', async: true },
          // { src: 'revealjs/plugin/zoom-js/zoom.js', async: true },
          { src: 'revealjs/plugin/notes/notes.js', async: true },
          { src: 'prismjs/prism.js', async: true }
          // { src: 'https://platform.twitter.com/widgets.js', async: true }
        ]
      })
    </script>
  

</body></html>